import * as i0 from '@angular/core';
import { Injectable, EventEmitter, TemplateRef, Component, ViewEncapsulation, Input, Output, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { __awaiter } from 'tslib';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { BehaviorSubject, skip, distinctUntilChanged, fromEvent, firstValueFrom, timer } from 'rxjs';

class ElementHighlighterService {
    constructor() {
        this.activeElementSubject = new BehaviorSubject(null);
        /* const svg = this.renderer.createElement('svg');
        const defs = this.renderer.createElement('defs');
        this.renderer.appendChild(svg, defs);
        this.renderer.appendChild(document.body, svg); */
        /* const svg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
        svg.setAttribute('height',"0");
        svg.setAttribute('width',"0");
        var svgNS = svg.namespaceURI;
        const defs = document.createElementNS(svgNS,'defs');
        const clipPath = document.createElementNS(svgNS,'clipPath');
        const rect = document.createElementNS(svgNS,'rect');
        rect.setAttribute('x',"5");
        rect.setAttribute('y',"5");
        rect.setAttribute('width',"500");
        rect.setAttribute('height',"500");
        rect.setAttribute('fill','#95B3D7');
        clipPath.id = 'spTest';
        svg.appendChild(defs);
        defs.appendChild(clipPath);
        clipPath.appendChild(rect);
        document.body.appendChild(svg); */
    }
    get activeElementChanges() {
        return this.activeElementSubject.asObservable();
    }
    setActiveElement(key) {
        /* if(this.activeElementSubject.getValue() === key) {
            this.close();
        } */
        this.activeElementSubject.next(key);
    }
    close() {
        this.activeElementSubject.next(null);
    }
}
ElementHighlighterService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
ElementHighlighterService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class ElementHighlighterComponent {
    constructor(elementRef, highlightService, renderer, viewContainerRef) {
        this.elementRef = elementRef;
        this.highlightService = highlightService;
        this.renderer = renderer;
        this.viewContainerRef = viewContainerRef;
        this.highlightElement = '';
        this.highlightNext = '';
        this.highlightTooltip = '';
        this.prefferedTooltipPosition = 'top';
        this._highlightDisableBackdropAutoClose = false;
        this.spHighlightBackDropClick = new EventEmitter();
        this.currentKey = null;
    }
    get highlightDisableBackdropAutoClose() { return this._highlightDisableBackdropAutoClose; }
    set highlightDisableBackdropAutoClose(value) {
        this._highlightDisableBackdropAutoClose = coerceBooleanProperty(value);
    }
    ngAfterViewInit() {
        this.highlightSubscription = this.highlightService.activeElementChanges.pipe(skip(1), distinctUntilChanged()).subscribe(key => {
            this.currentKey = key;
            if (key === this.highlightElement) {
                this.positionElement();
            }
            else {
                if (key !== this.highlightElement) {
                    this.elementRef.nativeElement.classList.remove('sp-highlighted');
                }
                if (key === null) {
                    this.removeOverlay();
                }
            }
        });
        this.resizeSubscription = fromEvent(window, 'resize').subscribe(() => {
            var _a;
            let el = document.querySelector(`[spHighlight="${this.currentKey}"]`);
            if (this.currentKey === this.highlightElement && el) {
                const boundingRect = el.getBoundingClientRect();
                (_a = document.querySelector('.sp-highlight-overlay')) === null || _a === void 0 ? void 0 : _a.setAttribute('style', `
                    clip-path: polygon(
                        0% 0%, 
                        0% 100%, 
                        ${boundingRect.left}px 100%,
                        ${boundingRect.left}px ${boundingRect.top}px,
                        ${boundingRect.right}px ${boundingRect.top}px, 
                        ${boundingRect.right}px ${boundingRect.bottom}px, 
                        ${boundingRect.left}px ${boundingRect.bottom}px, 
                        ${boundingRect.left}px 100%, 
                        100% 100%, 100% 0%
                    )`);
                /* document.querySelector('.sp-highlight-tooltip')?.setAttribute('style',
                `
                    top: ${this.highlightTooltip instanceof TemplateRef ? `${boundingRect.top - 30}px` : `${boundingRect.top - 60}px`};
                    left: ${boundingRect.left + (boundingRect.width / 2)}px;
                    transform: translateX(-50%);
                    padding: ${this.highlightTooltip instanceof TemplateRef ? '0' : '10px'};
                `
                ); */
                this.checkTooltipPosition();
            }
        });
    }
    ngOnDestroy() {
        if (this.highlightSubscription) {
            this.highlightSubscription.unsubscribe();
        }
        if (this.resizeSubscription) {
            this.resizeSubscription.unsubscribe();
        }
    }
    positionElement() {
        var _a;
        const boundingRect = this.elementRef.nativeElement.getBoundingClientRect();
        this.elementRef.nativeElement.classList.add('sp-highlighted');
        const overlayEl = this.renderer.createElement('div');
        this.renderer.addClass(overlayEl, 'sp-highlight-overlay');
        //this.renderer.addClass(document.body, 'sp-highlight-overlay-active');
        this.renderer.setStyle(overlayEl, 'clip-path', `
            polygon(
                0% 0%, 
                0% 100%, 
                ${boundingRect.left}px 100%,
                ${boundingRect.left}px ${boundingRect.top}px,
                ${boundingRect.right}px ${boundingRect.top}px, 
                ${boundingRect.right}px ${boundingRect.bottom}px, 
                ${boundingRect.left}px ${boundingRect.bottom}px, 
                ${boundingRect.left}px 100%, 
                100% 100%, 100% 0%
            )`);
        this.renderer.listen(overlayEl, 'click', (event) => {
            var _a;
            if (((_a = this.highlightNext) === null || _a === void 0 ? void 0 : _a.length) || !this._highlightDisableBackdropAutoClose) {
                this.removeOverlay(true);
            }
            const obj = { key: this.highlightElement, event };
            this.spHighlightBackDropClick.emit(obj);
        });
        document.body.append(overlayEl);
        let tooltipEl;
        if (this.highlightTooltip instanceof TemplateRef) {
            tooltipEl = this.viewContainerRef.createEmbeddedView(this.highlightTooltip);
        }
        else {
            if ((_a = this.highlightTooltip) === null || _a === void 0 ? void 0 : _a.length) {
                tooltipEl = this.renderer.createElement('div');
                tooltipEl.innerHTML = this.highlightTooltip;
            }
        }
        if (tooltipEl) {
            const container = this.renderer.createElement('div');
            this.renderer.addClass(container, 'sp-highlight-tooltip');
            this.renderer.setStyle(container, 'padding', `${this.highlightTooltip instanceof TemplateRef ? '0' : '1rem'}`);
            this.renderer.addClass(document.body, 'sp-highlight-overlay-active');
            if (this.highlightTooltip instanceof TemplateRef) {
                for (var node of tooltipEl.rootNodes) {
                    this.renderer.appendChild(container, node);
                }
            }
            else {
                this.renderer.appendChild(container, tooltipEl);
            }
            document.body.append(container);
            dispatchEvent(new Event('resize'));
        }
    }
    checkTooltipPosition() {
        const boundingRect = this.elementRef.nativeElement.getBoundingClientRect();
        const container = document.querySelector('.sp-highlight-tooltip');
        if (container) {
            const tooltipRect = container.getBoundingClientRect();
            const positions = {
                top: () => {
                    this.renderer.removeClass(container, 'bottom');
                    this.renderer.removeClass(container, 'left');
                    this.renderer.removeClass(container, 'right');
                    this.renderer.addClass(container, 'top');
                    container.setAttribute('style', `
                        top: ${boundingRect.top - tooltipRect.height - 10}px;
                        left: ${boundingRect.left + (boundingRect.width / 2)}px;
                        padding: ${this.highlightTooltip instanceof TemplateRef ? '0' : '1rem'};
                        transform: translateX(-50%);
                    `);
                },
                right: () => {
                    this.renderer.removeClass(container, 'top');
                    this.renderer.removeClass(container, 'left');
                    this.renderer.removeClass(container, 'bottom');
                    this.renderer.addClass(container, 'right');
                    container.setAttribute('style', `
                        top: ${boundingRect.top + (boundingRect.height / 2) - 10}px;
                        left: ${boundingRect.right + 10}px;
                        padding: ${this.highlightTooltip instanceof TemplateRef ? '0' : '1rem'};
                        transform: translateY(-50%);
                    `);
                },
                left: () => {
                    this.renderer.removeClass(container, 'top');
                    this.renderer.removeClass(container, 'bottom');
                    this.renderer.removeClass(container, 'right');
                    this.renderer.addClass(container, 'left');
                    container.setAttribute('style', `
                        top: ${boundingRect.top + (boundingRect.height / 2) - 10}px;
                        left: ${boundingRect.left - tooltipRect.width - 10}px;
                        padding: ${this.highlightTooltip instanceof TemplateRef ? '0' : '1rem'};
                        transform: translateY(-50%);
                    `);
                },
                bottom: () => {
                    this.renderer.removeClass(container, 'top');
                    this.renderer.removeClass(container, 'left');
                    this.renderer.removeClass(container, 'right');
                    this.renderer.addClass(container, 'bottom');
                    container.setAttribute('style', `
                        top: ${boundingRect.bottom + 10}px;
                        left: ${boundingRect.left + (boundingRect.width / 2)}px;
                        padding: ${this.highlightTooltip instanceof TemplateRef ? '0' : '1rem'};
                        transform: translateX(-50%);
                    `);
                }
            };
            let checkOrder = ['top', 'right', 'left', 'bottom'];
            positions[this.prefferedTooltipPosition]();
            checkOrder.splice(checkOrder.indexOf(this.prefferedTooltipPosition), 1);
            let isClipping = !this.isElementInViewport(container);
            while (checkOrder.length && isClipping) {
                positions[checkOrder[0]]();
                checkOrder.splice(0, 1);
                isClipping = !this.isElementInViewport(container);
            }
            if (isClipping) {
                positions[this.prefferedTooltipPosition]();
            }
        }
    }
    removeOverlay(showNext = false) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const overlayEl = document.querySelector('.sp-highlight-overlay');
            const tooltipEl = document.querySelector('.sp-highlight-tooltip');
            if (overlayEl) {
                this.renderer.addClass(overlayEl, 'fade-out');
            }
            if (tooltipEl) {
                this.renderer.addClass(tooltipEl, 'fade-out');
            }
            yield firstValueFrom(timer(500));
            overlayEl === null || overlayEl === void 0 ? void 0 : overlayEl.remove();
            tooltipEl === null || tooltipEl === void 0 ? void 0 : tooltipEl.remove();
            if (((_a = this.highlightNext) === null || _a === void 0 ? void 0 : _a.length) && showNext) {
                this.highlightService.setActiveElement(this.highlightNext);
            }
            else {
                this.highlightService.close();
                this.renderer.removeClass(document.body, 'sp-highlight-overlay-active');
            }
        });
    }
    isElementInViewport(el) {
        var rect = el.getBoundingClientRect();
        return (rect.top >= 0 &&
            rect.left >= 0 &&
            rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) && /* or $(window).height() */
            rect.right <= (window.innerWidth || document.documentElement.clientWidth) /* or $(window).width() */);
    }
}
ElementHighlighterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterComponent, deps: [{ token: i0.ElementRef }, { token: ElementHighlighterService }, { token: i0.Renderer2 }, { token: i0.ViewContainerRef }], target: i0.ɵɵFactoryTarget.Component });
ElementHighlighterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.3", type: ElementHighlighterComponent, selector: "[spHighlight]", inputs: { highlightElement: ["spHighlight", "highlightElement"], highlightNext: ["spHighlightNext", "highlightNext"], highlightTooltip: ["spHighlightTooltip", "highlightTooltip"], prefferedTooltipPosition: ["spHighlightTooltipPosition", "prefferedTooltipPosition"], highlightDisableBackdropAutoClose: ["spHighlightDisableBackdropAutoClose", "highlightDisableBackdropAutoClose"] }, outputs: { spHighlightBackDropClick: "spHighlightBackDropClick" }, ngImport: i0, template: "<ng-content></ng-content>", styles: [".sp-highlight-overlay-active{overflow:hidden!important}.sp-highlighted{z-index:9999;position:relative}.sp-highlighted~.highlight-tooltip{opacity:1}.sp-highlight-overlay{--animation-duration: .5s;position:fixed;top:0;left:0;right:0;bottom:0;background:rgba(0,0,0,.5);z-index:9999;animation:fade-in var(--animation-duration) ease-in-out}.sp-highlight-overlay.fade-out{animation:fade-out var(--animation-duration);opacity:0}.sp-highlight-tooltip{--animation-duration: .5s;z-index:99999;position:fixed;background-color:#fff;opacity:1;border-radius:3px;animation:fade-in var(--animation-duration) ease-in-out}.sp-highlight-tooltip.top:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);bottom:0;left:50%;transform:translate(-50%,100%)}.sp-highlight-tooltip.right:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);top:50%;left:0;transform:translate(-100%,-50%) rotate(90deg)}.sp-highlight-tooltip.left:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);top:50%;right:0;transform:translate(100%,-50%) rotate(-90deg)}.sp-highlight-tooltip.bottom:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);top:0;left:50%;transform:translate(-50%,-100%) rotate(180deg)}.sp-highlight-tooltip.fade-out{animation:fade-out var(--animation-duration);opacity:0}@keyframes infinite-pulse{0%{transform:scale(1)}50%{transform:scale(.95)}to{transform:scale(1)}}@keyframes fade-in{0%{opacity:0}to{opacity:1}}@keyframes fade-out{0%{opacity:1}to{opacity:0}}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterComponent, decorators: [{
            type: Component,
            args: [{ selector: '[spHighlight]', encapsulation: ViewEncapsulation.None, template: "<ng-content></ng-content>", styles: [".sp-highlight-overlay-active{overflow:hidden!important}.sp-highlighted{z-index:9999;position:relative}.sp-highlighted~.highlight-tooltip{opacity:1}.sp-highlight-overlay{--animation-duration: .5s;position:fixed;top:0;left:0;right:0;bottom:0;background:rgba(0,0,0,.5);z-index:9999;animation:fade-in var(--animation-duration) ease-in-out}.sp-highlight-overlay.fade-out{animation:fade-out var(--animation-duration);opacity:0}.sp-highlight-tooltip{--animation-duration: .5s;z-index:99999;position:fixed;background-color:#fff;opacity:1;border-radius:3px;animation:fade-in var(--animation-duration) ease-in-out}.sp-highlight-tooltip.top:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);bottom:0;left:50%;transform:translate(-50%,100%)}.sp-highlight-tooltip.right:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);top:50%;left:0;transform:translate(-100%,-50%) rotate(90deg)}.sp-highlight-tooltip.left:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);top:50%;right:0;transform:translate(100%,-50%) rotate(-90deg)}.sp-highlight-tooltip.bottom:before{content:\"\";width:.5rem;height:.5rem;background-color:inherit;position:absolute;clip-path:polygon(50% 80%,0 0,100% 0);top:0;left:50%;transform:translate(-50%,-100%) rotate(180deg)}.sp-highlight-tooltip.fade-out{animation:fade-out var(--animation-duration);opacity:0}@keyframes infinite-pulse{0%{transform:scale(1)}50%{transform:scale(.95)}to{transform:scale(1)}}@keyframes fade-in{0%{opacity:0}to{opacity:1}}@keyframes fade-out{0%{opacity:1}to{opacity:0}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: ElementHighlighterService }, { type: i0.Renderer2 }, { type: i0.ViewContainerRef }]; }, propDecorators: { highlightElement: [{
                type: Input,
                args: ['spHighlight']
            }], highlightNext: [{
                type: Input,
                args: ['spHighlightNext']
            }], highlightTooltip: [{
                type: Input,
                args: ['spHighlightTooltip']
            }], prefferedTooltipPosition: [{
                type: Input,
                args: ['spHighlightTooltipPosition']
            }], highlightDisableBackdropAutoClose: [{
                type: Input,
                args: ['spHighlightDisableBackdropAutoClose']
            }], spHighlightBackDropClick: [{
                type: Output
            }] } });

class ElementHighlighterModule {
}
ElementHighlighterModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ElementHighlighterModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterModule, declarations: [ElementHighlighterComponent], imports: [CommonModule], exports: [ElementHighlighterComponent] });
ElementHighlighterModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterModule, providers: [ElementHighlighterService], imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: ElementHighlighterModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [ElementHighlighterComponent],
                    exports: [ElementHighlighterComponent],
                    providers: [ElementHighlighterService],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ElementHighlighterComponent, ElementHighlighterModule, ElementHighlighterService };
//# sourceMappingURL=sandstroms-element-highlighter.mjs.map
