import { BooleanInput } from '@angular/cdk/coercion';
import { AfterViewInit, ElementRef, EventEmitter, OnDestroy, Renderer2, TemplateRef, ViewContainerRef } from '@angular/core';
import { Subscription } from 'rxjs';
import { ElementHighlighterService } from '../element-highlighter.service';
import { SpHighlightTooltipPosition } from '../element-highlighter.model';
import * as i0 from "@angular/core";
export declare class ElementHighlighterComponent implements AfterViewInit, OnDestroy {
    private elementRef;
    private highlightService;
    private renderer;
    private viewContainerRef;
    highlightElement: string;
    highlightNext: string;
    highlightTooltip: string | TemplateRef<any>;
    prefferedTooltipPosition: SpHighlightTooltipPosition;
    get highlightDisableBackdropAutoClose(): BooleanInput;
    set highlightDisableBackdropAutoClose(value: BooleanInput);
    private _highlightDisableBackdropAutoClose;
    spHighlightBackDropClick: EventEmitter<{
        key: string;
        event: PointerEvent;
    }>;
    highlightSubscription: Subscription;
    resizeSubscription: Subscription;
    private currentKey;
    constructor(elementRef: ElementRef, highlightService: ElementHighlighterService, renderer: Renderer2, viewContainerRef: ViewContainerRef);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    positionElement(): void;
    checkTooltipPosition(): void;
    removeOverlay(showNext?: boolean): Promise<void>;
    isElementInViewport(el: any): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<ElementHighlighterComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ElementHighlighterComponent, "[spHighlight]", never, { "highlightElement": "spHighlight"; "highlightNext": "spHighlightNext"; "highlightTooltip": "spHighlightTooltip"; "prefferedTooltipPosition": "spHighlightTooltipPosition"; "highlightDisableBackdropAutoClose": "spHighlightDisableBackdropAutoClose"; }, { "spHighlightBackDropClick": "spHighlightBackDropClick"; }, never, ["*"]>;
}
